<script src="@#file#(fillpoly.js)" type="text/javascript"></script>

<p>Pseudokod algoritma za popunjavanje konveksnog poligona prikazan je u nastavku.</p>
<div style="background-color: #FFFFAA; padding: 5px; border-left: 3px solid #00AA00;">
<p>Zadano: vrhovi V[1], V[2], ..., V[n]</p>
<ol>
<li>Odredi jednadžbe svih bridova b[i] i njihov karakter (lijevi ili desni).</li> 
<li>Odredi:<br>
    x<sub>min</sub>=min(V[1].x, ...,V[n].x)<br>
    x<sub>max</sub>=max(V[1].x, ...,V[n].x)<br>
    y<sub>min</sub>=min(V[1].y, ...,V[n].y)<br>
    y<sub>max</sub>=max(V[1].y, ...,V[n].y)</li>
<li>Ponovi za svaki y iz y<sub>min</sub> do y<sub>max</sub>:
<ol>
  <li>Postavi L na x<sub>min</sub>, D = x<sub>max</sub>.</li>
  <li>Za svaki brid b[i], i = 1 do n napravi:
   <ol>
    <li>Pronađi x-koordinatu sjecišta pravca na kojem leži b[i] i sken-linije y: neka je to S.</li>
    <li>Ako je b[i] lijevi brid i S&gt;L, ažuriraj L=S.</li>
    <li>Ako je b[i] desni brid i S&lt;D, ažuriraj D=S.</li>
   </ol>
  </li>
  <li>Ako je L&lt;=D, obojaj sve slikovne elemente od (L,y) do (D,y).</li>
</ol>
</li>
</ol>
</div>

<p>Rad algoritma možete pratiti kroz interaktivnu demonstraciju u nastavku. Pritiskom na gumb korak prolazite korak po korak kroz algoritam. U pojedinim koracima algoritma utvrđene vrijednosti za trenutno lijevo sjecište (varijabla L) odnosno za trenutno desno sjecište (varijabla D) prikazivat će se u tablici ispod rasterskog prikaza. U prvom koraku algoritam određuje minimalne i maksimalne x i y vrijednosti analizom zadanih vrhova. Nakon prelaska u svaku novu sken-liniju, algoritam resetira L na x<sub>min</sub> i D na x<sub>max</sub>. Potom za svaki brid treba dva koraka. U prvom koraku prikazuje sjecište pravca na kojem leži brid i sken-linije. U drugom koraku ažurira L ili D (ili ne radi ništa) ovisno je li brid bio lijevi ili desni te kakva je x-koordinata pronađenog sjecišta u odnosu na L tj. D.</p>
<p>Gumbom "Reset" postupak možete vratiti na početak. Gumbom "Automatski" možete zatražiti da algoritam sam nastavi raditi korake bez potrebe da pritišćete gumb "Korak". Ako ste pokrenuli automatsko napredovanje kroz algoritam, novi pritisak na gumb "Automatski" to će zaustaviti.</p> 

  <div width="500" height="500" style="position:relative; width:500px; margin: auto;">
  <canvas id="myCanvas1" width="500" height="500" style="border: 1px solid white;"></canvas>
  </div>
  <script type="text/javascript">
    var vertexes = [{x: 10,y:2, l:"V1"}, {x: 13,y:8, l:"V2"}, {x: 9,y:17, l:"V3"}, {x: 6,y:11, l:"V4"}];
    var brcanvas1 = new RasterDisplay("myCanvas1", 20, 20);
    brcanvas1.fullLines = [
      {x0:vertexes[0].x,y0:vertexes[0].y,x1:vertexes[1].x,y1:vertexes[1].y,c:"#FF0000",l:"b1"},
      {x0:vertexes[1].x,y0:vertexes[1].y,x1:vertexes[2].x,y1:vertexes[2].y,c:"#FF0000",l:"b2"},
      {x0:vertexes[2].x,y0:vertexes[2].y,x1:vertexes[3].x,y1:vertexes[3].y,c:"#FF0000",l:"b3"},
      {x0:vertexes[3].x,y0:vertexes[3].y,x1:vertexes[0].x,y1:vertexes[0].y,c:"#FF0000",l:"b4"}
    ];
    var alg1 = new FillAlgorithm1(vertexes, brcanvas1, "alg1");
    brcanvas1.points = vertexes;
    brcanvas1.showPointLabels = true;
    brcanvas1.showLineLabels = true;
    brcanvas1.showPoints = true;
    brcanvas1.paint();

    var inthndle = null;
    function toggleAutomatic() {
      if(inthndle==null) {
        inthndle = setInterval(function() {
          alg1.next();
          if(!alg1.hasNext()) { clearInterval(inthndle); inthndle=null; }
        }, 250);
      } else {
        clearInterval(inthndle); inthndle=null;
      }
    }
  </script>
<div style="text-align: center">
  <button onclick="alg1.reset(); document.getElementById('alg1btn').disabled=false;">Reset</button>
  <button id="alg1btn" onclick="alg1.next(); if(!alg1.hasNext()) this.disabled=true;">Korak</button>
  <button onclick="toggleAutomatic();">Automatski</button>
  <table>
  <tr>
    <th>xmin</th><th>ymin</th><th>xmax</th><th>ymax</th><th>yscan</th><th>L</th><th>D</th>
  </tr>
  <tr>
    <td id="alg1_xmin">-</td><td id="alg1_ymin">-</td><td id="alg1_xmax">-</td><td id="alg1_ymax">-</td><td id="alg1_yscan">-</td><td id="alg1_varL">-</td><td id="alg1_varD">-</td>
  </tr>
  </table>
</div>
